/* LocaleInformation_nl.java --
   Copyright (C) 2004  Free Software Foundation, Inc.

This file is part of GNU Classpath.

GNU Classpath is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU Classpath is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Classpath; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */


// This file was automatically generated by gnu.localegen from LDML nl.xml

package gnu.java.locale;

import java.util.ListResourceBundle;

public class LocaleInformation_nl extends ListResourceBundle
{

private static final String collation_rules = 
  "<0<1<2<3<4<5<6<7<8<9<A,a<b,B<c,C<d,D<e,E<f,F<g,G<h,H<i,I<j,J<k,K" +
  "<l,L<m,M<n,N<o,O<p,P<q,Q<r,R<s,S<t,T<u,U<v,V<w,W<x,X<y,Y<z,Z";

private static final String[] months = { "januari", "februari", "maart", 
  "april", "mei", "juni", "juli", "augustus", "september", "october",
  "november", "december", null };

private static final String[] shortMonths = { "jan", "feb", "mrt", "apr", "mei",
  "jun", "jul", "aug", "sep", "oct", "nov", "dec", null };

private static final String[] weekdays = { null, "zondag", "maandag", "dinsdag",
  "woensdag", "donderdag", "vrijdag", "zaterdag" };

private static final String[] shortWeekdays = { null, "zo", "ma", "di", "wo",
  "do", "vr", "za" };

private static final String[] ampms = { "AM", "PM" };

private static final String[] eras = { "BC", "AD" };

private static final String[][] zoneStrings =
{
  // European time zones.  The city names are a little bit random.
  { "WET", "West Europese Tijd", "WET", "West Europese Zomertijd", "WEST", "London" },
  { "CET", "Centraal Europese Tijd", "CET", "Centraal Europese Zomertijd", "CEST", "Amsterdam" },
  { "EET", "Oost Europese Tijd", "EET", "Oost Europese Zomertijd", "EEST", "Istanbul" },
};

private static final String localPatternChars = "GyMdhHmsSEDFwWakKz"; // Not a mistake!

private static final String shortDateFormat = "dd-MM-yy";

private static final String mediumDateFormat = "dd-MMM-yy";

private static final String longDateFormat = "dd MMMM yyyy";

private static final String fullDateFormat = "EEEE dd MMMM yyyy";

private static final String defaultDateFormat = mediumDateFormat;

private static final String shortTimeFormat = "HH:mm";

private static final String mediumTimeFormat = "HH:mm:ss";

private static final String longTimeFormat = "HH:mm:ss";

private static final String fullTimeFormat = "HH:mm:ss z";

private static final String defaultTimeFormat = shortTimeFormat;

private static final String currencySymbol = "fl";

private static final String intlCurrencySymbol = "NLG";

private static final String decimalSeparator = ",";

private static final String exponential = "E";

private static final String digit = "#";

private static final String groupingSeparator = ",";

private static final String infinity = "\u221e";

private static final String NaN = "\ufffd";

private static final String minusSign = "-";

private static final String monetarySeparator = ",";

private static final String patternSeparator = ";";

private static final String percent = "%";

private static final String perMill = "\u2030";

private static final String zeroDigit = "0";

private static final Object[][] contents =
{
  { "collation_rules", collation_rules },
  { "months", months },
  { "shortMonths", shortMonths },
  { "weekdays", weekdays },
  { "shortWeekdays", shortWeekdays },
  { "ampms", ampms },
  { "eras", eras },
  { "zoneStrings", zoneStrings },
  { "localPatternChars", localPatternChars },
  { "shortDateFormat", shortDateFormat },
  { "mediumDateFormat", mediumDateFormat },
  { "longDateFormat", longDateFormat },
  { "fullDateFormat", fullDateFormat },
  { "defaultDateFormat", defaultDateFormat },
  { "shortTimeFormat", shortTimeFormat },
  { "mediumTimeFormat", mediumTimeFormat },
  { "longTimeFormat", longTimeFormat },
  { "fullTimeFormat", fullTimeFormat },
  { "defaultTimeFormat", defaultTimeFormat },
  { "currencySymbol", currencySymbol },
  { "intlCurrencySymbol", intlCurrencySymbol },
  { "decimalSeparator", decimalSeparator },
  { "digit", digit },
  { "exponential", exponential },
  { "groupingSeparator", groupingSeparator },
  { "infinity", infinity },
  { "NaN", NaN },
  { "minusSign", minusSign },
  { "monetarySeparator", monetarySeparator },
  { "patternSeparator", patternSeparator },
  { "percent", percent },
  { "perMill", perMill },
  { "zeroDigit", zeroDigit },
};

  public Object[][] getContents() { return contents; }
}
